/* In en.DM00083560.pdf:   */



/* p77 */
.equ PERIPH_BASE,	(0x40000000)
.equ APB1PERIPH_BASE,	(PERIPH_BASE)
.equ APB2PERIPH_BASE,	(PERIPH_BASE + 0x00010000)
.equ AHB1PERIPH_BASE,	(PERIPH_BASE + 0x00020000)
.equ AHB2PERIPH_BASE,	(PERIPH_BASE + 0x08000000)



/* 6.4 p223 */
/* Reset and Clock Control */
//typedef struct {
.equ RCC_CR,		0x00
.equ RCC_ICSR,		0x04
.equ RCC_CFGR,		0x08
.equ RCC_PLLCFGR,	0x0C
.equ RCC_PLLSAI1CFGR,	0x10
.equ RCC_PLLSAI2CFGR,	0x14
.equ RCC_CIER,		0x18
.equ RCC_CIFR,		0x1c
.equ RCC_CICR,		0x20
.equ RCC_RESERVED0,	0x24
.equ RCC_AHB1RSTR,	0x28
.equ RCC_AHB2RSTR,	0x2c
.equ RCC_AHB3RSTR,	0x30
.equ RCC_RESERVED1,	0x34
.equ RCC_APB1RSTR1,	0x38
.equ RCC_APB1RSTR2,	0x3c
.equ RCC_APB2RSTR,	0x40
.equ RCC_RESERVED2,	0x44
.equ RCC_AHB1ENR,	0x48
.equ RCC_AHB2ENR,	0x4c
.equ RCC_AHB3ENR,	0x50
.equ RCC_RESERVED3,	0x54
.equ RCC_APB1ENR1,	0x58
.equ RCC_APB1ENR2,	0x5c
.equ RCC_APB2ENR,	0x60
.equ RCC_RESERVED4,	0x64
.equ RCC_AHB1SMENR,	0x68
.equ RCC_AHB2SMENR,	0x6C
.equ RCC_AHB3SMENR,	0x70
.equ RCC_RESERVED5,	0x74
.equ RCC_APB1SMENR1,	0x78
.equ RCC_APB1SMENR2,	0x7C
.equ RCC_APB2SMENR,	0x80
.equ RCC_RESERVED6,	0x84
.equ RCC_CCIPR,		0x88
.equ RCC_RESERVED7,	0x8C
.equ RCC_BDCR,		0x90
.equ RCC_CSR,		0x94

.equ RCC_CR_MSION,		(1<<0)
.equ RCC_CR_MSIRGSEL,		(1<<3)
.equ RCC_CR_MSIRANGE,		(0xf<<4)
.equ RCC_CR_HSION,		(1<<8)
.equ RCC_CR_HSIRDY,		(1<<10)
.equ RCC_CR_HSERDY,		(1<<17)
.equ RCC_CR_HSEBYP,		(1<<18)
.equ RCC_CR_PLLON,		(1<<24)
.equ RCC_CR_PLLRDY,		(1<<25)

.equ RCC_CFGR_SW,		(0x3)
.equ RCC_CFGR_SW_PLL,		(0x3)
.equ RCC_CFGR_SW_HSI,		(0x1)
.equ RCC_CFGR_HPRE,		(0xf<<4)

.equ RCC_CFGR_SWS,		(0x3<<2)
.equ RCC_CFGR_SWS_PLL,		(0x3<<2)

.equ RCC_PLLCFGR_PLLSRC,	(0x3)
.equ RCC_PLLCFGR_PLLSRC_HSI,	(0x2)
.equ RCC_PLLCFGR_PLLN,		(0xff<<8)
.equ RCC_PLLCFGR_PLLM,		(0x7<<4)
.equ RCC_PLLCFGR_PLLR,		(0x3<<25)
.equ RCC_PLLCFGR_PLLREN,	(1<<24)


.equ RCC_AHB2ENR_GPIOAEN,	(1<<0)
.equ RCC_AHB2ENR_GPIOBEN,	(1<<1)
.equ RCC_AHB2ENR_GPIOCEN,	(1<<2)
.equ RCC_AHB2ENR_GPIODEN,	(1<<3)
.equ RCC_AHB2ENR_GPIOEEN,	(1<<4)
.equ RCC_AHB2ENR_GPIOFEN,	(1<<5)
.equ RCC_AHB2ENR_GPIOGEN,	(1<<6)
.equ RCC_AHB2ENR_GPIOHEN,	(1<<7)
.equ RCC_AHB2ENR_GPIOIEEN,	(1<<8)

/* 6.4.19, p253 */
.equ RCC_APB1ENR1_LCDEN,	(1<<9)
.equ RCC_APB1ENR1_PWREN,	(1<<28)

/* 6.4.29, p272 */
.equ RCC_BDCR_LSEON,		(0x1<<0)	/* LSE Oscillator Enable */
.equ RCC_BDCR_LSERDY,		(0x1<<1)	/* LSE Oscillator Ready */
.equ RCC_BDCR_LSEBYP,		(0x1<<2)	/* LSE Oscillator Bypass */
.equ RCC_BDCR_RTCSEL,		(0x3<<8)
.equ RCC_BDCR_RTCSEL_LSE,	(0x1<<8)
.equ RCC_BDCR_RTCSEL_LSI,	(0x2<<8)
.equ RCC_BDCR_RTCSEL_HSE,	(0x3<<8)
.equ RCC_BDCR_RTCEN,		(0x1<<15)
.equ RCC_BDCR_BDRST,		(0x1<<16)	/* Backup domain sw reset */

.equ RCC_CSR_MSISRANGE,		(0xf<<8)
.equ RCC_CSR_LSION,		(1<<0)


.equ RCC_BASE,	(AHB1PERIPH_BASE + 0x1000)


/* General Purpose IO */
.equ GPIO_MODER,	0x00	/* 0x00 = Mode Register */
.equ GPIO_OTYPER,	0x04	/* 0x04 = Output Type Register */
.equ GPIO_OSPEEDR,	0x08	/* 0x08 = Output Speed Register */
.equ GPIO_PUPDR,	0x0C	/* 0x0C = Pull Up/Pull Down Register */
.equ GPIO_IDR,		0x10	/* 0x10 = Input Data Register */
.equ GPIO_ODR,		0x14	/* 0x14 = Output Data Register */
.equ GPIO_BSRR,		0x18	/* 0x18 = Bit Set/Reset Register (LOW) */
.equ GPIO_LCKR,		0x1C	/* 0x1C = Configuration Lock Register */
.equ GPIO_AFR,		0x20	/* 0x20 = Alternate Function (Low/High) Registers */
.equ GPIO_AFRL,		0x20	/* 0x20 = Alternate Function (Low/High) Registers */
.equ GPIO_AFH,		0x24	/* 0x20 = Alternate Function (Low/High) Registers */
.equ GPIO_BRR,		0x28
.equ GPIO_ASCR,		0x2C

.equ GPIOA_BASE,	(AHB2PERIPH_BASE + 0x0000)
.equ GPIOB_BASE,	(AHB2PERIPH_BASE + 0x0400)
.equ GPIOC_BASE,	(AHB2PERIPH_BASE + 0x0800)
.equ GPIOD_BASE,	(AHB2PERIPH_BASE + 0x0C00)
.equ GPIOE_BASE,	(AHB2PERIPH_BASE + 0x1000)

.equ MODER_INPUT,	0x00
.equ MODER_OUTPUT,	0x01
.equ MODER_ALT,		0x02
.equ MODER_ANALOG,	0x03


/* RTC -- Chapter 38.6 (p1238)*/
.equ RTC_TR,		0x00	/* 0x00 = Time Register */
.equ RTC_DR,		0x04	/* 0x04 = Date Register */
.equ RTC_CR,		0x08	/* 0x08 = Control Register */
.equ RTC_ISR,		0x0C	/* 0x0C = Init and Status Register */
.equ RTC_PRER,		0x10	/* 0x10 = Prescalar Register */
.equ RTC_WUTR,		0x14	/* 0x14 = Wakeup Time Register */
.equ RTC_RESERVED0,	0x18	/* 0x18 */
.equ RTC_ALRMAR,	0x1C	/* 0x1C = Alarm A register */
.equ RTC_ALRMBR,	0x20	/* 0x20 = Alarm B register */
.equ RTC_WPR,		0x24	/* 0x24 = Write Protect register */


.equ RTC_BASE,	(APB1PERIPH_BASE + 0x2800)


/* LCD -- Chapter 25.6 (p767,p790) */

.equ LCD_CR,		0x00	/* 0x00 = Control Register */
.equ LCD_FCR,		0x04	/* 0x04 = Frame Control Register */
.equ LCD_SR,		0x08	/* 0x08 = Status Register */
.equ LCD_CLR,		0x0C	/* 0x0C = Clear Register */
.equ LCD_RESERVED0,	0x10	/* 0x10 = Unused */
.equ LCD_RAM,		0x14	/* 0x14 - 0x50 */


.equ LCD_BASE,	(APB1PERIPH_BASE + 0x2400)


/* p790 */
.equ LCD_CR_LCDEN,		(0x1<<0)
.equ LCD_CR_VSEL,		(0x1<<1)
.equ LCD_CR_DUTY_MASK,		(0x7<<2)
.equ LCD_CR_DUTY_1_4,		(0x3<<2)
.equ LCD_CR_BIAS_MASK,		(0x3<<5)
.equ LCD_CR_BIAS_1_3,		(0x2<<5)
.equ LCD_CR_MUX_SEG,		(0x1<<7)


/* p791 */
.equ LCD_FCR_PON_MASK,		(0x7<<4)
.equ LCD_FCR_PON7,		(0x7<<4)
.equ LCD_FCR_CC_MASK,		(0x7<<10)
.equ LCD_FCR_CC_LCD7,		(0x7<<10)

/* p794 */
.equ LCD_SR_ENS,		(0x1<<0)
.equ LCD_SR_UDR,		(0x1<<2)
.equ LCD_SR_UDD,		(0x1<<3)
.equ LCD_SR_RDY,		(0x1<<4)
.equ LCD_SR_FCRSF,		(0x1<<5)




/* Power -- 5.4 p184 */
.equ PWR_CR1,	0x00	/* 0x00 = Control Register 1 */
.equ PWR_CR2,	0x04	/* 0x04 = Control Register 2 */
.equ PWR_CR3,	0x08	/* 0x08 = Control Register 3 */
.equ PWR_CR4,	0x0c	/* 0x0C = Control Register 4 */


/* Table 1 p80 */
.equ PWR_BASE,	(APB1PERIPH_BASE + 0x7000)

.equ PWR_CR1_DBP,	(1<<8)	/* Disable Backup Write Protection */

